// NOTE : Below is a String I use to add to the data sent to the Nextion Display
//        And to verify the end of the string for incoming data.
//        Replace 3 x Serial2.write(0xff);
String  endChar = String(char(0xff)) + String(char(0xff)) + String(char(0xff));
String  dfd  = ""; // data from display
////////////////// ASYNC DELAYS ///////////////////////////////
// NOTE : Accelerometer Async Delay 
unsigned	long accelDelay = 0;// NOTE : 4,294,967,295
/////////////////////////////////////////////////////////////////////////////////////////
//////////////  NOTE : Frequency of data collection /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
int	accelLength = 20;// NOTE : Frequency of data collection
/////////////////////////////////////////////////////////////////////////////////////////
//////////////  NOTE : Lenght of time  taking data /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
unsigned  long readingStart = 0;// NOTE : reset to zero at status 1
int readingLengh = 3000;// NOTE : Lenght of time  taking data

// NOTE : Hall Effect Async Delay 
unsigned  long hallDelay = 0;// NOTE : 4,294,967,295
int hallLength = 1000;
////////////////////////////////////////////////////////////////////
// NOTE : Comment out the next two lines if using an Arduino with more than 1 serial port(MEGA)
#include <SoftwareSerial.h>
SoftwareSerial Serial2(2, 3); // RX, TX
// NOTE : Motor Config
int MTR1 = 5;
int MTR2 = 6;
// NOTE : HALLEFECT
int HE_SENSOR = 11 ; // define the Hall magnetic sensor interface
int HE_COUNTER = 0;
int HE_STATE = 0;
// NOTE : Accelerometer
int PROG_STATUS = 0;// NOTE : used to switch between data collection and setup
#include <Wire.h>// NOTE : SDA -> A4 : SCL -> A5
int xArray[200]; 
int xArrayCounter = 0;
int yArray[200]; 
int yArrayCounter = 0;

void setup() {
  Serial.begin(9600);
  Serial2.begin(9600);
  pinMode(13,OUTPUT);
  // NOTE : Motor SETUP
  pinMode(MTR1, OUTPUT);
  digitalWrite(MTR1, LOW);
  pinMode(MTR2, OUTPUT);
  digitalWrite(MTR2, LOW);
  // NOTE : HALL EFECT SENSOR LINE AS INPUT
  pinMode (HE_SENSOR, INPUT); 
  // NOTE : ACCELEROMETER
  Wire.begin();
  delay(200);
  Wire.beginTransmission(0x68);// NOTE : Power Management Register
  Wire.write(0x6B);
  Wire.write(0x00);
  Wire.endTransmission(true);
  delay(200);
  Wire.beginTransmission(0x68);// NOTE : GYRO Register
  Wire.write(0x1B);
  Wire.write(0x10);// NOTE : 1000 deg per second setting
  Wire.endTransmission(true);
  delay(200);
  Wire.beginTransmission(0x68);// NOTE : Accelerometer Register
  Wire.write(0x1C);
  Wire.write(0x08);// NOTE : 4g setting
  Wire.endTransmission(true);
  delay(2000);
}

void loop() {
  // NOTE : HALLEFECT
  if(HE_STATE != digitalRead(HE_SENSOR)){
    HE_STATE = !HE_STATE;
    if(HE_STATE==1){
      HE_COUNTER++;
      //Serial.println("HE COUNTER = " + String(HE_COUNTER));
    }
  }
  // NOTE : COLLECT CHARACTERS FROM NEXTION DISPLAY
  if(Serial2.available()){
    inputFunction();
  }
  ////////////////////////////////////// ASYNC DELAYS
  // NOTE : HALL EFFECT DELAY 
  if(PROG_STATUS == 0){ // NOTE : don't read the hall effect if in vibration collection
    readingStart = millis();
    if(millis() > hallDelay){
      hallDelay+=hallLength;
      hallFunction();
    }
  }
  // NOTE : GET VARIABLES SEt TO READ DATA
  if(PROG_STATUS == 1){
    Serial2.print("n0.val=" + String(PROG_STATUS) + endChar);
    readingStart = millis();
    accelDelay = millis();
    PROG_STATUS = 2;
  }
  // NOTE : ACCELEROMETER DELAY
  if(PROG_STATUS == 2){
    if(millis() > accelDelay){
      accelDelay+=accelLength;
      accelFunction();
      if(millis() > (readingStart + readingLengh)){
        PROG_STATUS=3;
        Serial2.print("n0.val=" + String(PROG_STATUS) + endChar);
      }
    }
  }
  // NOTE : STOP collecting data and populate the screen
  if(PROG_STATUS == 3){
    Serial.println(" Bytes used in xArray = " + String(xArrayCounter));
    // NOTE : display the data on the Nextion Waveform
    //         All the data is collected, no need to worry about wasting time at this point
    //         BUT -- you are not collecting Hall Effect data and have not been since accel collection
    while(xArrayCounter>0){
      // NOTE : ADD data between points
      // value decreasing
      if(xArray[xArrayCounter+1]>xArray[xArrayCounter]){
        int diff = ((xArray[xArrayCounter+1]-xArray[xArrayCounter])/4); 
        for(int x=1;x<5;x++)
          Serial2.print("add 1,0," + String(xArray[xArrayCounter+1]-(x*diff))+ endChar);
      }
      // value increasing
      else{
        int diff = ((xArray[xArrayCounter]-xArray[xArrayCounter+1])/4);
        for(int x=1;x<5;x++)
          Serial2.print("add 1,0," + String(xArray[xArrayCounter+1]+(x*diff))+ endChar);
      }
      // NOTE : display actual collected data
      Serial2.print("add 1,0," + String(xArray[xArrayCounter--]) + endChar);
    }
    while(yArrayCounter>0){
      // NOTE : ADD data between points
      // value decreasing 
      if(yArray[yArrayCounter+1]>yArray[yArrayCounter]){
        int diff = ((yArray[yArrayCounter+1]-yArray[yArrayCounter])/4); 
        for(int x=1;x<5;x++)
          Serial2.print("add 1,1," + String(yArray[yArrayCounter+1]-(x*diff))+ endChar);
      }
      // value increasing
      else{
        int diff = ((yArray[yArrayCounter]-yArray[yArrayCounter+1])/4);
        for(int x=1;x<5;x++)
          Serial2.print("add 1,1," + String(yArray[yArrayCounter+1]+(x*diff))+ endChar);
      }
      // NOTE : display actual collected data
      Serial2.print("add 1,1," + String(yArray[yArrayCounter--]) + endChar);
    }
    Serial2.print("bt0.val=0" + endChar);
    // RESET the hall effect collection variables
    HE_COUNTER=0;
    hallDelay=millis()+hallLength;
    // NOTE : RESET PROG_STATUS back to collecting RPM data
    PROG_STATUS=0;
  }
}
